Core - Bug # 43540

Task # 52304 (Resolved): Performance issues

Status: Resolved Priority: Must have
Author: Dmitry Dulepov Category: TypoScript
Created: 2012-12-03 Assigned To: Dmitry Dulepov
Updated: 2013-12-17 Due date:

TYPO3 Version: 6.0

PHP Version:

Complexity: hard

Is Regression: No

Sprint Focus:

Subject: TS is fetched from cache incorrectly sometimes

Description

If §GLOBALS[TYPO3_CONF_VARS'|['FE']['defaultTypoScript_constants'] or
$GLOBALS['TYPO3_CONF_VARS'|['FE'|'defaultTypoScript_setup'] are set in the Install tool, cached TS will not be found in cache.
This would result in TS parsing every time when there are USER_INT objects on the page. Generally it will slow down the page with
USER_INT objects by at least 300% comparing to the non-cached version.

More information
When template parser processes the TS, it makes a hash to load a cached version of TS:
$this->runThroughTemplates($theRootLine);

$rowSumHash = md5('ROWSUM:' . serialize($this->rowSum));
$result = \TYPO3\CMS\Frontend\Page\PageRepository::getHash($rowSumHash);

There TS can be fetched from the cache. If nothing is returned, the TS is parsed and stored into the cache:
$this->generateConfig();

$rowSumHash = md5('ROWSUM:' . serialize($this->rowSum));
\TYPO3\CMS\Frontend\Page\PageRepository::storeHash($rowSumHash, serialize($cc['all']), ' TMPL_CONDITIONS_ALL");

Function generateConfig() prepends values from the above-mentioned variables before processing the data. The earlier called
function runThroughtTemplates() does not do that. If the variables are empty, it does not make any difference and everything is
cached. But if those variables are not empty (even if there is a single space), the $this->rowSum will be different in two quoted code
extracts above. Thus TS will be stored with one hash value and the next request will try to retrieve it with another hash value. This
means that cached TS will never be retrieved and will be always parsed.

We were able to decrease page generation from 2.88s to 0.8s by fixing the issue. 2 seconds make a huge difference in speed and
load of the web server.

Related issues:
blocks Core - Bug # 53352: Template Analyzer produces wrong results Resolved 2013-11-05
Associated revisions

Revision 4fbb2b58 - 2013-02-06 14:50 - Dmitry Dulepov

[BUGFIX] TS is fetched from cache incorrectly sometimes

If $TYPO3_CONF_VARS['FE']['defaultTypoScript_constants'] or

$TYPO3_CONF_VARS['FE"['defaultTypoScript_setup'] are set in the Install

tool, cached TS will not be found in cache. This would result in TS
parsing every time when there are USER_INT objects on the page.
Generally it will slow down the page with USER_INT objects by at least
300% comparing to the cached version.

Change-Id: 1a0fd65a35897¢c71d60c48c0b03098ce67ad16c70
Resolves: #43540

Releases: 4.5, 4.6, 4.7, 6.0, 6.1

Reviewed-on: https://review.typo3.org/16939

Reviewed-by: Adrian Dymorz
Tested-by: Adrian Dymorz
Reviewed-by: Stefan Neufeind
Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring
Reviewed-by: Sebastian Michaelsen
Reviewed-by: Dmitry Dulepov
Tested-by: Dmitry Dulepov

Revision 09f3b6af - 2013-09-30 19:44 - Dmitry Dulepov

[BUGFIX] TS is fetched from cache incorrectly sometimes

If $TYPO3_CONF_VARS['FE']['defaultTypoScript_constants'] or
$TYPO3_CONF_VARS['FE"'defaultTypoScript_setup'] are set through
the PHP code, cached TS will not be found in cache. This would

result in TS parsing every time when there are USER_INT objects

on the page. It may slow down the page with USER_INT objects

by about 300% comparing to the cached version.

This change is re-added after it got reverted due to lack of reviews in
1a0fd65a35897¢71d60c48c0b03098ceb7ad16¢70.

Change-Id: 1ef3a065451644423b236489729716b906f3d4500
Resolves: #43540

Releases: 4.5,4.7, 6.0, 6.1, 6.2

Reviewed-on: https://review.typo3.org/18072

Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert

Revision 6b2512a9 - 2013-09-30 19:54 - Dmitry Dulepov

[BUGFIX] TS is fetched from cache incorrectly sometimes

If $TYPO3_CONF_VARS['FE']['defaultTypoScript_constants'] or
$TYPO3_CONF_VARS['FE'defaultTypoScript_setup'] are set through
the PHP code, cached TS will not be found in cache. This would

result in TS parsing every time when there are USER_INT objects

on the page. It may slow down the page with USER_INT objects

by about 300% comparing to the cached version.

This change is re-added after it got reverted due to lack of reviews in
1a0fd65a35897¢71d60c48c0b03098ce67ad16¢70.

Change-Id: 1ef3a065451644423b236489729716b906f3d4500
Resolves: #43540

Releases: 4.5, 4.7, 6.0, 6.1, 6.2

Reviewed-on: https://review.typo3.orq/24177

Reviewed-by: Jigal van Hemert
Tested-by: Jigal van Hemert

Revision 8e1ea888 - 2013-09-30 19:59 - Dmitry Dulepov

[BUGFIX] TS is fetched from cache incorrectly sometimes

If $TYPO3_CONF_VARS['FE']['defaultTypoScript_constants'] or
$TYPO3_CONF_VARS['FE'defaultTypoScript_setup'] are set through
the PHP code, cached TS will not be found in cache. This would

result in TS parsing every time when there are USER_INT objects

on the page. It may slow down the page with USER_INT objects

by about 300% comparing to the cached version.

This change is re-added after it got reverted due to lack of reviews in
1a0fd65a35897¢71d60c48c0b03098ce67ad16¢70.

Change-Id: 1ef3a065451644423b236489729716b906f3d4500
Resolves: #43540

Releases: 4.5, 4.7, 6.0, 6.1, 6.2

Reviewed-on: https://review.typo3.0rg/24178

Reviewed-by: Jigal van Hemert

Tested-by: Jigal van Hemert

Revision f8f155e5 - 2013-10-23 19:39 - Jigal van Hemert

[BUGFIX] TS is fetched from cache incorrectly sometimes

If $TYPO3_CONF_VARS['FE']['defaultTypoScript_constants'] or
$TYPO3_CONF_VARS['FE"'defaultTypoScript_setup'] are set through
the PHP code, cached TS will not be found in cache. This would

result in TS parsing every time when there are USER_INT objects

on the page. It may slow down the page with USER_INT objects

by about 300% comparing to the cached version.

This change is re-added after it got reverted due to lack of reviews in
1a0fd65a35897¢71d60c48c0b03098ce67ad16¢70.
https://review.typo3.org/24177
Change-Id: 1ef3a065451644423b236489729716b906f3d4500
Resolves: #43540

Releases: 4.5,4.7, 6.0, 6.1, 6.2

Reviewed-on: https:/review.typo3.org/24182

Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind

History

#1 - 2012-12-03 10:37 - Dmitry Dulepov

Should be read: "...comparing to the cached version".

#2 - 2012-12-03 10:42 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at http://review.typo3.org/16939

#3 - 2012-12-03 14:59 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/16939

#4 - 2013-02-06 15:00 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/18056

#5 - 2013-02-06 15:30 - Dmitry Dulepov
- Status changed from Under Review to Resolved
- % Done changed from 10 to 100

Applied in changeset commit:4fbb2b5852a98b1eb3e935d79d612468896291f1.

#6 - 2013-02-06 15:41 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/18059

#7 - 2013-02-06 15:48 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-6 has been pushed to the review server.
It is available at https://review.typo3.org/18061

#8 - 2013-02-06 15:49 - Gerrit Code Review

Patch set 2 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/18059

#9 - 2013-02-06 15:55 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 has been pushed to the review server.
It is available at https://review.typo3.org/18062

#10 - 2013-02-06 20:29 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/18072

#11 - 2013-02-06 20:34 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/18072

#12 - 2013-02-27 04:50 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18072

#13 - 2013-03-04 20:15 - Gerrit Code Review

Patch set 1 for branch master_new has been pushed to the review server.

It is available at https://review.typo3.org/18621

#14 - 2013-03-23 12:41 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/18072

#15 - 2013-05-19 18:40 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18072

#16 - 2013-09-30 10:21 - Markus Klein
- Parent task set to #52338
- Is Regression set to No

#17 - 2013-09-30 10:21 - Markus Klein
- Parent task changed from #52338 to #52304

#18 - 2013-09-30 17:41 - Kasper Ligaard

This solves the problem described in this thread: http:/forum.typo3.org/index.php/m/695487/#page top

#19 - 2013-09-30 19:42 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18072

#20 - 2013-09-30 19:51 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.

It is available at https://review.typo3.org/24177

#21 - 2013-09-30 19:58 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/24178

#22 - 2013-09-30 20:30 - Dmitry Dulepov
- Status changed from Under Review to Resolved

Applied in changeset commit:8e1ea8886d8e83272e36000d0a7a1bc31fde206d.

#23 - 2013-09-30 20:40 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/24182

#24 - 2013-10-23 19:46 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 has been pushed to the review server.
It is available at https://review.typo3.org/24981

#25 - 2013-10-23 20:30 - Jigal van Hemert
- Status changed from Under Review to Resolved
Applied in changeset commit:f8f155e51465551681e5e14c5f16f8a7e719d9d4.

#26 - 2013-11-28 14:08 - Simon Schaufelberger

Hey, Why is this NOT included in 4.5??? so sad...

#27 - 2013-12-17 01:11 - Markus Klein

@Simon: It will be finally included.
